<?php

/**
 * @file
 * Google Drive api connection
 * for google doc listing.
 */
/*
 *  A page callback for when you go to the droogle_drive url.
 */
function droogle_list_files() {
  drupal_add_js(drupal_get_path('module', 'droogle_drive') . '/js/droogle_drive_list.js', array(
    'scope' => 'footer'));
  drupal_add_css(drupal_get_path('module', 'droogle_drive') . '/css/droogle_drive_list.css');
  global $user;
  $user_email = $user->mail;
  $droogle_drive_title_text = variable_get('droogle_drive_title_text', '');
  $doctype = $_POST['docType'];
  $ajaxtype = $_POST['docType'];
  $owner_fullname = $_POST['ownerFullname'];
  $owner_email = $_POST['ownerEmail'];
  if ($droogle_drive_title_text == "") {
    $droogle_drive_title_text = variable_get('droogle_title_text', '');/* Use old table value */
  }
  drupal_set_title($droogle_drive_title_text);
  unset($result);
  $return_result = droogle_drive_gdrive_connect('droogle_drive');
  $client = $return_result['client'];
  $service = $return_result['service'];
  if (isset($return_result['authUrl'])) {
    $authUrl = $return_result['authUrl'];
  }
  // If we're signed in then lets try to upload our file.
  $refresh_token = variable_get('droogle_drive_refresh_token', '');
  if ($refresh_token == "") {
    $refresh_token = variable_get('droogle_refresh_token', '');
  }
  if(!empty($refresh_token) && $client->isAccessTokenExpired()) {
    $client->refreshToken($refresh_token);
  }
  if ($client->getAccessToken()) {
    $content = theme('droogle_drive_list_files', array('service' => $service, 'user_email' => $user_email));
  }
  elseif (isset($authUrl)) {
    $content = '<a class="login" href=' . $authUrl . '>Connect Me!</a></div>';
  }
  if ($ajaxtype) {
    drupal_json_output(array(
      'successful' => 'success!',
      'doclink' => $content,
    ));
  } else {
    return $content;
  }
}



function droogle_folderlist() {
  drupal_add_js(drupal_get_path('module', 'droogle_drive') . '/js/droogle_drive_list.js', array(
    'scope' => 'footer'));
  drupal_add_css(drupal_get_path('module', 'droogle_drive') . '/css/droogle_drive_list.css');
  $droogle_drive_title_text = variable_get('droogle_drive_title_text', '');
  $owner_email = $_POST['ownerEmail'];


  if ($droogle_drive_title_text == "") {
    $droogle_drive_title_text = variable_get('droogle_title_text', '');/* Use old table value */
  }
  drupal_set_title($droogle_drive_title_text);
  unset($result);
  $return_result = droogle_drive_gdrive_connect('droogle_drive');
  $client = $return_result['client'];
  $service = $return_result['service'];
  if (isset($return_result['authUrl'])) {
    $authUrl = $return_result['authUrl'];
  }
  // If we're signed in then lets try to upload our file.
  $refresh_token = variable_get('droogle_drive_refresh_token', '');
  if ($refresh_token == "") {
    $refresh_token = variable_get('droogle_refresh_token', '');
  }
  if(!empty($refresh_token) && $client->isAccessTokenExpired()) {
    $client->refreshToken($refresh_token);
  }
  if ($client->getAccessToken()) {
    $content = theme('droogle_drive_list_folders', array('service' => $service, 'owner_email' => $owner_email));
  }
  elseif (isset($authUrl)) {
    $content = '<a class="login" href=' . $authUrl . '>Connect Me!</a></div>';
  }

  drupal_json_output(array(
    'successful' => 'success!',
    'folderLink' => $content,
  ));

}




/*
 *  A page callback for when you go to the droogle_drive url.
 */
function droogle_shared_list() {
  drupal_add_js(drupal_get_path('module', 'droogle_drive') . '/js/droogle_drive_list.js', array(
    'scope' => 'footer'));
  drupal_add_css(drupal_get_path('module', 'droogle_drive') . '/css/droogle_drive_list.css');
  global $user;
  $user_email = $user->mail;
  $droogle_drive_title_text = variable_get('droogle_drive_title_text', '');
  $button_type = $_POST['buttonType'];
  $file_id = $_POST['fileId'];

  unset($result);
  $return_result = droogle_drive_gdrive_connect('droogle_drive');
  $client = $return_result['client'];
  $service = $return_result['service'];
  if (isset($return_result['authUrl'])) {
    $authUrl = $return_result['authUrl'];
  }
  // If we're signed in then lets try to upload our file.
  $refresh_token = variable_get('droogle_drive_refresh_token', '');
  if ($refresh_token == "") {
    $refresh_token = variable_get('droogle_refresh_token', '');
  }
  if(!empty($refresh_token) && $client->isAccessTokenExpired()) {
    $client->refreshToken($refresh_token);
  }
  if ($client->getAccessToken()) {
    $content = theme('droogle_drive_shared_listing', array('service' => $service, 'user_email' => $user_email, 'file_id' => $file_id));
  }
  elseif (isset($authUrl)) {
    $content = '<a class="login" href=' . $authUrl . '>Connect Me!</a></div>';
  }

  drupal_json_output(array(
    'successful' => 'success!',
    'doclink' => $content,
  ));

}

/**
 * Implements of hook_theme().
 *
 * @param array $variables
 *   an array with google document listings.
 *
 * @return string
 *   html with listing of google folders owned by selected owner
 *   to be output to the screen.
 */
function theme_droogle_list_folders($variables) {
  $service = $variables['service'];

  $ajax_owner_email = $variables['owner_email'];

  $files = $service->files->listFiles();

  $file_list = $files->getItems();


  $owner_content = '';

  foreach ($file_list as $file) {
    $fileId = $file['id'];
    if ($file['mimeType'] != 'application/vnd.google-apps.folder' || (isset($file['explicitlyTrashed']) && $file['explicitlyTrashed'] == 1)) {
      //Only list folders, just files (for now). It's displaying all files in folders anyhow.
      continue;
    } else {
      // get owner info from google drive folder and compare
      $owner_email = $file['data']['owners'][0]['emailAddress'];
      if ($owner_email == $ajax_owner_email) {
        $owner_content .= '<li class="droogle-owned-folder-list">';
//        $owner_content .=   '<a href="' . $file["alternateLink"] . '">';
        $owner_content .=     '<img class="droogle-drive-doc-file-icon" src="' . $file["iconLink"] . '">' . $file["title"];
//        $owner_content .=   '</a>';
        $owner_content .=   '<span class="select-status"></span>';
        $owner_content .=   '<span class="hidden droogle-document-shared-list-fileid">' . $fileId . '</span>';
        $owner_content .= '</li>';

      }
    }
  }
  $content =  '<ul class="droogle-drive-folder-listing">';
  $content .=   '<li id="droogle-folder-owner-list-title" class="expanded">Select Destination Folder (optional)</li>';
  $content .=   '<li class="droogle-owned-folder-list my-drive selected">My Drive (default)<span class="select-status">selected</span></li>';
  $content .=    $owner_content;
  $content .= '</ul>';


  return $content;
}



/**
 * Implements of hook_theme().
 *
 * @param array $variables
 *   an array with google document listings.
 *
 * @return string
 *   html with listing of google docs to be output to the screen.
 */
function theme_droogle_list_files($variables) {

  $service = $variables['service'];

  $user_email = $variables['user_email'];

  $files = $service->files->listFiles();

  $file_list = $files->getItems();


  $owner_content = '';
  // Below line if for debugging.
  // $content .= '<div class="shortened">File List:  <pre> ' . print_r($file_list, TRUE) . '</pre></div></div>';
  foreach ($file_list as $file) {
    $owner_email = $file['data']['owners'][0]['emailAddress'];
    $fileId = $file['id'];

    if ($owner_email == $user_email) {
      $owner_content .= '<li class="droogle-owned-doc-list">';
      $owner_content .=   '<a href="' . $file["alternateLink"] . '">';
      $owner_content .=     '<img class="droogle-drive-doc-file-icon" src="' . $file["iconLink"] . '">' . $file["title"];
      $owner_content .=   '</a>';
      $owner_content .=   '<button class="droogle-document-get-shared-list">';
      $owner_content .=     'Show Sharing';
      $owner_content .=     '<span class="hidden droogle-document-shared-list-fileid">' . $fileId . '</span>';
      $owner_content .=     '<span class="hidden droogle-document-shared-list-useremail">' . $user_email . '</span>';
      $owner_content .=    '</button>';
      $owner_content .=   '<button class="please-standby get-doc-list">';
      $owner_content .=     'Please Standby';
      $owner_content .=    '</button>';
      $owner_content .=   '<button class="droogle-document-hide-shared-list">';
      $owner_content .=     'Hide Sharing';
      $owner_content .=    '</button>';
      $owner_content .=   '<button class="droogle-document-show-shared-list">';
      $owner_content .=     'Show Sharing';
      $owner_content .=    '</button>';
      $owner_content .=    '<div class="droogle-drive-shared-list-links-wrapper"></div>';
      $owner_content .= '</li>';
    }
    /* Getting the shared files from the following code takes too long so we won't use it, but still don't want to delete it either */
    /*
        else {
          $shared_list = droogle_drive_list_retrievePermissions($service, $fileId);
          foreach ($shared_list as $shared_person) {
            $shared_email = $shared_person['emailAddress'];
            if ($shared_email == $user_email && (!isset($file['explicitlyTrashed']) && $file['explicitlyTrashed'] != 1)) {
              $shared_content .= '<a href="' . $file["alternateLink"] . '"><div><img class="droogle-drive-doc-file-icon" src="' . $file["iconLink"] . '">' . $file["title"] . '</div></a>';
            }
          }
        }
    */
//    $content .= '<a href="' . $file["alternateLink"] . '"><div><img class="droogle-drive-doc-file-icon" src="' . $file["iconLink"] . '">' . $file["title"] . '</div></a>';
  }

  $content = '<ul id="droogle-drive-document-listing">';
  $content .= '<li id="droogle-owner-content">Shared Google Docs Owned by You</li>';
  $content .= $owner_content;
//  $content .= '<li id="droogle-shared-content">Shared with You</li>';
//  $content .= $shared_content;
  $content .= '</ul>';

  return $content;
}


function theme_droogle_shared_listing($variables) {
  $service = $variables['service'];
  $user_email = $variables['user_email'];
  $file_id = $variables['file_id'];

  $shared_list = droogle_drive_list_retrievePermissions($service, $file_id);
  $shared_content = '';
  foreach ($shared_list as $shared_person) {
    $shared_email = $shared_person['emailAddress'];
    $shared_name = $shared_person['name'];
    $shared_role = $shared_person['role'];
    if ($shared_email != NULL) {
//      if ($user_email != $shared_email) {
      if ($shared_name == NULL) {
        $shared_name = $shared_email;
      }
      $email_button = theme('droogle_hangout_email_button', array('email' => $shared_email, 'text' => FALSE));
      if (module_exists('droogle_drive')) {
        $droogle_button = theme('droogle_drive_create_invite_button', array('email' => $shared_email, 'fullname' => $shared_name, 'text' => FALSE));
      }
      if (module_exists('jabber')) {
        $chat_button = theme('droogle_hangout_chat_button', array('email' => $shared_email,  'fullname' => $shared_name, 'text' => FALSE));
      }


      $hangout_button = theme('droogle_hangout_invite_button', array('email' => $shared_email, 'fullname' => $shared_name, 'text' =>FALSE));

      switch ($shared_role) {
        case 'owner':
          $shared_label = 'Is owner';
          break;
        case 'writer':
          $shared_label = 'Can edit';
          break;
        case 'reader':
          $shared_label = 'Can view';
          break;
      }

      $shared_content .= '<li class="droogle-shared-list-item">';
      $shared_content .=   '<span  class="droogle-shared-list-name">';
      $shared_content .=     $shared_name;
      $shared_content .=   '</span>';
      $shared_content .=   '<span class="droogle-shared-list-name-role">';
      $shared_content .=     ': ' . $shared_label;
      $shared_content .=   '</span>';
      $shared_content .=   '<span class="droogle-button-array">';
      $shared_content .=     $chat_button;
      $shared_content .=     $email_button;
      $shared_content .=     $hangout_button;
      $shared_content .=     $droogle_button;
      $shared_content .=    '<span class="droogle-button-array-last"></span>';
      $shared_content .=   '</span>';
      $shared_content .= '</li>';
//      }
    }
  }
  $content =  '<ul class="droogle-shared-list">';
  $content .= '<li class="droogle-shared-list-title">This Document is Shared With<span class="close-droogle-shared-list">x</span></span></li>';
  $content .= $shared_content;
  $content .= '</ul>';
  return $content;
}
/**
 *  Content for Droogle Doc List Block.
 */
function droogle_list_block() {
  drupal_add_js(drupal_get_path('module', 'droogle_drive') . '/js/droogle_drive_list.js', array(
    'scope' => 'footer'));
  drupal_add_css(drupal_get_path('module', 'droogle_drive') . '/css/droogle_drive_list.css');
  global $user;
  $email = $user->mail;
  $uid = $user->uid;


  $content  = '<div id="droogle-drive-doc-list-wrapper">';
  $content .=   '<button id="droogle-drive-list-submit">Stop Pushing!</button>';
  $content .=   '<div class="please-standby-wrapper">';
  $content .=     '<p class="please-standby">Please Standby...</p>';
  $content .=   '</div><!-- .please-standby-wrapper -->';
  $content .=   '<div id="droogle-drive-list-links-wrapper"></div>';
  $content .= '</div><!--#droogle-drive-doc-list-wrapper -->';
  return $content;
}

/**
 * Retrieve a list of permissions.
 *
 * @param Google_DriveService $service Drive API service instance.
 * @param String $fileId ID of the file to retrieve permissions for.
 * @return Array List of permissions.
 */
function droogle_list_retrievePermissions($service, $fileId) {
  try {
    $permissions = $service->permissions->listPermissions($fileId);
    return $permissions->getItems();
  } catch (Exception $e) {
    print "An error occurred: " . $e->getMessage();
  }
  return NULL;
}

/**
 * Generates the output for the hello/world page.
 *
 * @param $item
 *   How many items to show from the hello_world database.
 *
 * @return
 *   HTML-formatted output from the hello_world table
 *   in the database.
 */
function theme_hello_world_primary_page2($items) {
  $content = '<p><b>Here are all the messages recorded in the hello_world custom table!!!!! </b></p>';
  if (isset($items['items'])) {
    $results = db_query('SELECT * from hello_world limit ' . $items['items']);
  }
  else {
    $results = db_query('SELECT * from hello_world');
  }
  foreach($results as $row) {
    $content .= 'Row: ' . $row->hid . ', Message: ' . $row->message . ', Timestamp: ' . $row->timestamp . '</br>';
  }
  return $content;
}