<?php
 
/**
 * @file
 * Contains \Drupal\hello_world\Plugin\Block\HelloWorldBlock1
 */
 
namespace Drupal\droogle\Plugin\Block;
 
use Drupal\block\BlockBase;
use Drupal\block\Annotation\Block;
use Drupal\Core\Annotation\Translation;

/**
 * Provides a simple block.
 *
 * @Block(
 *   id = "droogle_drive_block1",
 *   admin_label = @Translation("Droogle Drive Block1"),
 *   module = "droogle"
 * )
 */
class DroogleDriveDocLoader extends BlockBase {
 
  /**
   * Implements \Drupal\block\BlockBase::blockBuild().
   */
  public function build() {
    $this->configuration['label'] = t('Droogle Drive Doc List');
    return array(
      '#markup' => t('Hello from a Droogle custom block') . $this->droogleDriveDocCreateBlock(),
      '#attached' => array(
        'css' => array(drupal_get_path('module', 'droogle') . '/css/droogle_drive.css'),
        'js' => array(drupal_get_path('module', 'droogle') . '/js/droogle_drive.js'),
        'js' => array(drupal_get_path('module', 'droogle') . '/js/droogle_drive_invite_all.js'),
      ),
    );
  }

  protected function droogleDriveDocCreateBlock() {
    $user = \Drupal::currentUser();
    $email = $user->mail;
    $uid = $user->uid;
    $fullname = $email;

    if (\Drupal::moduleHandler()->moduleExists('droogle_drive_login')) {
      $result = db_query("SELECT u.name, u.mail, field_google_plus_first_name_value AS first, field_google_plus_last_name_value AS last
                       FROM {users} u
                       LEFT OUTER JOIN {field_data_field_google_plus_first_name} fn ON u.uid = fn.entity_id
                       LEFT OUTER JOIN {field_data_field_google_plus_last_name} ln ON u.uid = ln.entity_id
                       WHERE uid = :uid", array(':uid' => $uid));

      foreach ($result as $row) {
        $username = $row->name;
        $firstname = $row->first;
        $lastname = $row->last;
        $fullname = $firstname . ' ' . $lastname;
      }
    }
    if (db_table_exists('field_data_field_first_name') && db_table_exists('field_data_field_last_name')) {
      $result = db_query("SELECT u.name, u.mail, field_first_name_value AS first, field_last_name_value AS last
                       FROM {users} u
                       LEFT OUTER JOIN {field_data_field_first_name} fn ON u.uid = fn.entity_id
                       LEFT OUTER JOIN {field_data_field_last_name} ln ON u.uid = ln.entity_id
                       WHERE uid = :uid", array(':uid' => $uid));

      foreach ($result as $row) {
        $username = $row->name;
        $firstname = $row->first;
        $lastname = $row->last;
        $fullname = $firstname . ' ' . $lastname;
      }
    }

    $content  = '<div id="droogle-drive-header-wrapper">';
    $content .= theme('droogle_drive_create_invite_button', array('email' => $email, 'fullname' => $fullname));
    $content .= '<div id="droogle-drive-user-email">' . $email . '</div>';
    $content .= '<div id="droogle-drive-user-fullname">' . $fullname . '</div>';
    $content .= '</div>';
    $content .= '<div id="droogle-drive-outer-create-invite-wrapper">';
    /***  begin popup block dom ***/
    $content .=   '<div id="droogle-drive-create-invite-wrapper">';
    $content .=       '<div class="droogle-drive-create-invite-wrapper-header-slant-45"></div>';
    $content .=     '<div id="droogle-drive-create-invite-wrapper-header">';
    $content .=       '<span id="droogle-drive-create-invite-wrapper-header-title">Create a Google Doc</span>';
    $content .=       '<div id="close-droogle-drive-create-invite-wrapper">x</div>';
    $content .=     '</div><!--#droogle-drive-create-invite-wrapper-header-->';
    $content .=     '<div id="droogle-drive-create-invite-content-wrapper" class="no-submit-button">';
    /***  begin invitation list dom ***/
    $content .=       '<div id="droogle-drive-invite-wrapper">';
    $content .=         '<div id="droogle-drive-invite-instructions">Click any <span class="droogle-drive-logo">link</span> found in the Contact List to invite more people.</div>';
    $content .=         '<span id="droogle-drive-invite-title"></span>';

    $content .=         '<ul id="droogle-drive-landing-site">';
    $content .=         '</ul>';



    $content .=       '</div><!-- #droogle-drive-invite-wrapper -->';
    /***  begin destination folder selection dom ***/
    $content .=       '<div id="droogle-drive-folder-listing-wrapper">';

    $content .=           '<li id="droogle-drive-get-folder">';
    $content .=             '<span id="droogle-drive-folder-owner-email" class="owner"></span>';
    $content .=            '<span id="droogle-drive-folder-owner-fullname" class="owner"></span>';
    $content .=             '<span class="text-balloon-wrapper"><span class="text-balloon">';
    $content .=               "Select Destination Folder (optional)" ;
    $content .=             '</span></span>';
    $content .=	          '</li>';
    $content .=         '</ul>';
    $content .=         '<div id="droogle-drive-get-folder-results"></div>';
    $content .=         '<span class="droogle-drive-select-folder-footnote">Save file in “My Drive” folder or choose folder from the list above.</span>';
    $content .=         '<span class="droogle-drive-select-folder-footnote">Note: Add folders to list by <span id="gdrive-add-button">sharing folder</span> with gdrive@babson.edu in ';
    $content .=           '<a target="_blank" href="https://drive.google.com/a/babson.edu">Google Drive.</a>';
    $content .=         '</span><!-- .droogle-drive-select-folder-footnote -->';
    $content .=         '<ul class="droogle-drive-folder-listing-button">';
    $content .=       '</div><!-- #ddroogle-drive-folder-listing-wrapper -->';
    /***  begin select create submit button dom ***/
    $content .=       '<div id="droogle-drive-doc-create-btn-wrapper">';
    $content .=         '<div id="droogle-drive-controller-btn-title" class="expanded">Select Document Type</div>';
    $content .=         '<div class="droogle-drive-doc-create-btn selected" id="droogle-drive-document">';
    $content .=           'Document';
    $content .=           '<span class="text-balloon-wrapper"><span class="text-balloon">';
    $content .=             'Create Document';
    $content .=           '</span></span>';
    $content .=           '<span class="select-status">selected</span>';
    $content .=	        '</div>';
    $content .=         '<div class="droogle-drive-doc-create-btn" id="droogle-drive-spreadsheet">';
    $content .=           'Spreadsheet';
    $content .=           '<span class="text-balloon-wrapper"><span class="text-balloon">';
    $content .=             'Create Spreadsheet';
    $content .=           '</span></span>';
    $content .=           '<span class="select-status"></span>';
    $content .=	        '</div>';
    $content .=         '<div class="droogle-drive-doc-create-btn" id="droogle-drive-presentation">';
    $content .=           'Presentation';
    $content .=           '<span class="text-balloon-wrapper"><span class="text-balloon">';
    $content .=             'Create Presentation';
    $content .=           '</span></span>';
    $content .=           '<span class="select-status"></span>';
    $content .=	        '</div>';
    $content .=         '<div class="droogle-drive-doc-create-btn" id="droogle-drive-drawing">';
    $content .=           'Drawing';
    $content .=           '<span class="text-balloon-wrapper"><span class="text-balloon">';
    $content .=             'Create Drawing';
    $content .=           '</span></span>';
    $content .=           '<span class="select-status"></span>';
    $content .=	        '</div>';
    $content .=         '<div class="droogle-drive-doc-create-btn" id="droogle-drive-folder">';
    $content .=           'Folder';
    $content .=           '<span class="text-balloon-wrapper"><span class="text-balloon">';
    $content .=             'Create Folder';
    $content .=           '</span></span>';
    $content .=           '<span class="select-status"></span>';
    $content .=	        '</div>';
    $content .=       '</div><!-- #droogle-drive-doc-create-btn-wrapper -->';
    /***  begin create submit button dom, defaults to droogle drive document ***/
    $content .=       '<div id="droogle-drive-doc-create-submit-wrapper">';
    $content .=         '<button id="droogle-drive-doc-create-submit" class="droogle-drive-document" name="">';
    $content .=           '<span id="choose-doc-text">Create Document</span>';
    $content .=           '<span id="droogle-drive-owner-email" class="owner"></span>';
    $content .=           '<span id="droogle-drive-writer-email" class="writer"></span>';
    $content .=           '<span id="droogle-drive-reader-email" class="reader"></span>';
    $content .=           '<span id="droogle-drive-folder-id"></span>';
    $content .=         '</button>';
    $content .=       '</div><!-- #droogle-drive-doc-create-btn-wrapper -->';
    /***  begin please standby message dom ***/
    $content .=       '<div class="please-standby-wrapper">';
    $content .=         '<p class="please-standby create-doc">Please Standby...</p>';
    $content .=       '</div>';
    /***  begin controller button dom ***/

    $content .=         '<ul id="droogle-drive-doc-link-list-wrapper">';
    $content .=         '</ul>';

    $content .=       '<button id="droogle-drive-controller-back-btn" class="doctype-select">';
//  $content .=         '<span class="arrowhead"></span>';
    $content .=         '<span class="btn-text">Back</span>';
    $content .=	      '</button>';
    $content .=       '<button id="droogle-drive-controller-btn" class="folder-select">';
    $content .=         'Next';
    $content .=	      '</button>';
    $content .=       '<div class="float-kill"></div>';


    $content .=     '</div><!--#droogle-drive-create-invite-content-wrapper -->';
    $content .=   '</div><!--#droogle-drive-create-invite-wrapper -->';
    /*** End popup block dom ***/
    $content .= '</div><!--#droogle-drive-outer-create-invite-wrapper -->';
    return $content;
  }
}

