<?php
 
/**
 * @file
 * Contains \Drupal\hello_world\Plugin\Block\HelloWorldBlock1
 */
 
namespace Drupal\droogle\Plugin\Block;
 
use Drupal\block\BlockBase;
use Drupal\block\Annotation\Block;
use Drupal\Core\Annotation\Translation;

/**
 * Provides a simple block.
 *
 * @Block(
 *   id = "droogle_drive_block1",
 *   admin_label = @Translation("Droogle Drive Block1"),
 *   module = "droogle"
 * )
 */
class DroogleDriveInvite extends BlockBase {
 
  /**
   * Implements \Drupal\block\BlockBase::blockBuild().
   */
  public function build() {
    $this->configuration['label'] = t('Droogle Drive Doc List');
    return array(
      '#markup' => t('Hello from a Droogle custom block') . $this->droogleDriveDocInviteBlock(),
      '#attached' => array(
        'css' => array(drupal_get_path('module', 'droogle') . '/css/droogle_drive_list.css'),
        'js' => array(drupal_get_path('module', 'droogle') . '/js/droogle_drive_list.js'),
      ),
    );
  }

  protected function droogleDriveDocInviteBlock() {
    $user = \Drupal::currentUser();
    $role = $user->roles;
    $arg0 = arg(0);
    $nid = arg(1);
    $arg2 = arg(2);
    $arg3 = arg(3);
    $arg4 = arg(4);
    module_load_include('inc', 'droogle_drive', 'droogle_drive_html');
    $block['subject'] = t('Google Drive Invitation');

    if ($arg0 == 'node' && is_numeric($nid)) {
      if ( $arg2 == 'content'
        || $arg2 == 'blogs-list'
        || $arg2 == 'track'
        || $arg2 == 'log'
        || $arg2 == NULL) {
        if ( $arg3 == 'forum'
          || $arg3 == NULL) {
          if ( $arg4 == 'topic'
            || $arg4 == NULL) {
            $content = $this->droogleDriveDocInviteBlockMeatOfCode();
          }
        }
      }
    }
    else {
//          $block['content'] = FALSE;
    }
    return $content;
  }

  protected droogleDriveDocInviteBlockMeatOfCode() {
    $droogle_button = $this->droogleDriveCreateInviteButton($email, $fullname, $text);
    $invite_all_button = $this->droogleDriveCreateInviteAllButton($email, $fullname, $text);
    $content = '';
    //  $content .= $droogle_button;
    $content .= $invite_all_button;
    return $content;
  }

  protected function droogleDriveCreateInviteButton($variables) {
    $email = $variables['email'];
    $text = $variables['text'];
    if ($variables['text'] == TRUE) {
      $text = 'Google Drive';
    } else {
      $text = '';
    }
    $fullname = $variables['fullname'];
    if (is_null($fullname) || $fullname =='') {
      $fullname = $email;
    }
    $content  = '<div class="droogle-drive-create-invite-btn-wrapper">';
    $content .=   '<button class="droogle-drive-create-invite-btn" name="' . $email . '">' . $text;
    $content .=     '<span class="button-fullname" style="display:none;">' . $fullname . '</span>';
    $content .=     '<span class="text-balloon-wrapper"><span class="text-balloon">';
    $content .=       'google drive';
    $content .=     '</span></span>';
    $content .=	'</button>';
    $content .= '</div><!--#droogle-drive-doc-invite-btn-wrapper -->';
    return $content;
  }

  protected function droogleDriveCreateInviteAllButton($variables) {
    $email = $variables['email'];
    $text = $variables['text'];
    if ($variables['text'] == TRUE) {
      $text = 'Create and Share Google Doc';
    } else {
      $text = '';
    }
    $fullname = $variables['fullname'];
    if (is_null($fullname) || $fullname =='') {
      $fullname = $email;
    }
    $content  = '<div class="droogle-drive-create-invite-all-btn-wrapper">';
    $content .=   '<button class="droogle-drive-create-invite-all-btn" name="' . $email . '">' . $text;
    $content .=     '<span class="button-fullname" style="display:none;">' . $fullname . '</span>';
    $content .=     '<span class="text-balloon-wrapper"><span class="text-balloon">';
    $content .=       'google drive';
    $content .=     '</span></span>';
    $content .=	'</button>';
    $content .= '</div><!--#droogle-drive-doc-invite-btn-wrapper -->';
    return $content;
}


}

