<?php
 
/**
 * @file
 * Contains \Drupal\hello_world\Plugin\Block\HelloWorldBlock1
 */
 
namespace Drupal\droogle\Plugin\Block;
 
use Drupal\block\BlockBase;
use Drupal\block\Annotation\Block;
use Drupal\Core\Annotation\Translation;

/**
 * Provides a simple block.
 *
 * @Block(
 *   id = "droogle_drive_block1",
 *   admin_label = @Translation("Droogle Drive Block1"),
 *   module = "droogle"
 * )
 */
class DroogleDriveListBlock extends BlockBase {
 
  /**
   * Implements \Drupal\block\BlockBase::blockBuild().
   */
  public function build() {
    $this->configuration['label'] = t('Droogle Drive Doc List');
    return array(
      '#markup' => t('Hello from a Droogle custom block') . $this->droogle_drive_list_block(),
      '#attached' => array(
        'css' => array(drupal_get_path('module', 'droogle') . '/css/droogle_drive_list.css'),
        'js' => array(drupal_get_path('module', 'droogle') . '/js/droogle_drive_list.js'),
      ),
    );
  }

  protected function droogle_drive_list_block() {
    $content  = '<div id="droogle-drive-doc-list-wrapper">';
    $content .=   '<button id="droogle-drive-list-submit">Stop Pushing!</button>';
    $content .=   '<div class="please-standby-wrapper">';
    $content .=     '<p class="please-standby">Please Standby...</p>';
    $content .=   '</div><!-- .please-standby-wrapper -->';
    $content .=   '<div id="droogle-drive-list-links-wrapper"></div>';
    $content .= '</div><!--#droogle-drive-doc-list-wrapper -->';
    return $content;
  }
}

