<?php
 
/**
 * @file
 * Contains \Drupal\hello_world\Plugin\Block\HelloWorldBlock1
 */
 
namespace Drupal\droogle\Plugin\Block;
 
use Drupal\block\BlockBase;
use Drupal\block\Annotation\Block;
use Drupal\Core\Annotation\Translation;

/**
 * Provides a simple block.
 *
 * @Block(
 *   id = "droogle_drive_block1",
 *   admin_label = @Translation("Droogle Drive Block1"),
 *   module = "droogle"
 * )
 */
class DroogleDriveOgBlock extends BlockBase {
 
  /**
   * Implements \Drupal\block\BlockBase::blockBuild().
   */
  public function build() {
    $this->configuration['label'] = t('Droogle OG Block');
    return array(
      '#markup' => t('Hello from a Droogle custom block') . $this->droogleDriveListFiles(),
      '#attached' => array(
        'css' => array(drupal_get_path('module', 'droogle') . '/css/droogle_drive_list.css'),
        'js' => array(drupal_get_path('module', 'droogle') . '/js/droogle_drive_list.js'),
      ),
    );
  }

  protected function droogleDriveListFiles() {
    $user = \Drupal::currentUser();
    $config = $this->config('droogle.settings');
    $user_email = $user->mail;
    $droogle_drive_title_text = $config->get('cache.droogle_drive_title_text');
    $doctype = $_POST['docType'];
    $ajaxtype = $_POST['docType'];
    $owner_fullname = $_POST['ownerFullname'];
    $owner_email = $_POST['ownerEmail'];
    if ($droogle_drive_title_text == "") {
      $droogle_drive_title_text = $config->get('cache.droogle_drive_title_text'); /* Use old table value */
    }
    drupal_set_title($droogle_drive_title_text);
    unset($result);
    $return_result = droogle_drive_gdrive_connect('droogle_drive');
    $client = $return_result['client'];
    $service = $return_result['service'];
    if (isset($return_result['authUrl'])) {
      $authUrl = $return_result['authUrl'];
    }
    // If we're signed in then lets try to upload our file.
    $refresh_token = $config->get('cache.droogle_drive_refresh_token');
    if ($refresh_token == "") {
      $refresh_token = $config->get('cache.droogle_refresh_token');
    }
    if(!empty($refresh_token) && $client->isAccessTokenExpired()) {
      $client->refreshToken($refresh_token);
    }
    if ($client->getAccessToken()) {
      $content = theme('droogle_drive_list_files', array('service' => $service, 'user_email' => $user_email));
    }
    elseif (isset($authUrl)) {
      $content = '<a class="login" href=' . $authUrl . '>Connect Me!</a></div>';
    }
    if ($ajaxtype) {
      drupal_json_output(array(
        'successful' => 'success!',
        'doclink' => $content,
      ));
    } else {
      return $content;
    }
  }

}

